package org.cs.util;

import java.util.HashMap;
import java.util.Map;

import org.cs.constants.Constants;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsRequest;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsResponse;
import com.aliyuncs.exceptions.ClientException;
import com.aliyuncs.http.MethodType;
import com.aliyuncs.profile.DefaultProfile;
import com.aliyuncs.profile.IClientProfile;

public class SmsUtil {
	
	public final static String	product			= "Dysmsapi";
	final static String			domain			= "dysmsapi.aliyuncs.com";			// 短信API产品域名（接口地址固定，无需修改）
	final static String			accessKeyId		= "LTAIFWhHEEKxKUMx";				// 你的accessKeyId,参考本文档步骤2
	final static String			accessKeySecret	= "LhWcnY7o9HB8luwImaUoqLEfa4u8aC";	// 你的accessKeySecret，参考本文档步骤2
	final static String			sign			= "东旭集团";

	public static int sendCode(String phone, String code, int type) {
		// 短信模板的内容
		String json = "{\"code\":\"" + code + "\",\"product\":\"" + product + "\"}";

		IClientProfile profile = DefaultProfile.getProfile("cn-hangzhou", accessKeyId, accessKeySecret);
		try {
			DefaultProfile.addEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);

			IAcsClient acsClient = new DefaultAcsClient(profile);
			// 组装请求对象
			SendSmsRequest req = new SendSmsRequest();
			// 使用post提交 
			req.setMethod(MethodType.POST);

			// 必填:待发送手机号。支持以逗号分隔的形式进行批量调用，批量上限为1000个手机号码,批量调用相对于单条调用及时性稍有延迟,验证码类型的短信推荐使用单条调用的方式
			req.setPhoneNumbers(phone);
			// 必填:短信签名-可在短信控制台中找到
			req.setSignName(sign);

			if (type == 1) { // 注册
				req.setTemplateCode("SMS_137735221");
			} else if (type == 2) { // 忘记密码
				req.setTemplateCode("SMS_137950394");
			} else if (type == 3) { // 手机号验证 - 修改手机号
				req.setTemplateCode("SMS_137735221");
			} else if (type == 4) { // 绑定银行卡
				req.setTemplateCode("SMS_82015054");
			} else if (type == 5) { // 修改支付密码验证码
				req.setTemplateCode("SMS_82135059");
			}

			// 必填:短信模板-可在短信控制台中找到
//			req.setTemplateCode("SMS_81620087");
			// 可选:模板中的变量替换JSON串,如模板内容为"亲爱的${name},您的验证码为${code}"时,此处的值为
			// 友情提示:如果JSON中需要带换行符,请参照标准的JSON协议对换行符的要求,比如短信内容中包含\r\n的情况在JSON中需要表示成\\r\\n,否则会导致JSON在服务端解析失败
			req.setTemplateParam(json);
			// 可选-上行短信扩展码(无特殊需求用户请忽略此字段)
			// request.setSmsUpExtendCode("90997");
			// 可选:outId为提供给业务方扩展字段,最终在短信回执消息中将此值带回给调用者
			// req.setOutId("yourOutId");
			// 请求失败这里会抛ClientException异常
			SendSmsResponse sendSmsResponse;
			sendSmsResponse = acsClient.getAcsResponse(req);
			if (sendSmsResponse.getCode() != null && sendSmsResponse.getCode().equals("OK")) {
				// 请求成功
				System.out.println("短信发送成功: phone: " + phone + "    code : " + code);
			}
			return 1;
		} catch (ClientException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return -1;
	}
	
//	final static String endPoint = "http://sms.bj.baidubce.com"; // SMS服务域名，可根据环境选择具体域名
//	final static String accessKeyId = "8bebe38b288f4bed9832e8291c6c654e";  // 发送账号安全认证的Access Key ID
//	final static String secretAccessKy = "e2d48ce585f941af9abfba59d8300f48"; // 发送账号安全认证的Secret Access Key
//	final static String invokeId = "fPtXvW9o-t98t-l7Hm"; // 发送使用签名的调用ID
//	
//	public static int sendCode(String phone, String code, int type) {
//		SmsClientConfiguration config = new SmsClientConfiguration();
//        config.setCredentials(new DefaultBceCredentials(accessKeyId, secretAccessKy));
//        config.setEndpoint(endPoint);
//
//        // 实例化发送客户端
//        SmsClient smsClient = new SmsClient(config);
//        // 定义请求参数
//        String templateCode = ""; // 本次发送使用的模板Code
//        
//        if (type == 1) { // 注册 
//        	templateCode = "smsTpl:e7476122a1c24e37b3b0de19d04ae901";
//		} else if (type == 2) { // 忘记密码
//			templateCode = "smsTpl:e7476122a1c24e37b3b0de19d04ae903";
//		} else if (type == 3) { // 手机号验证 - 修改手机号
//			templateCode = "smsTpl:e7476122a1c24e37b3b0de19d04ae901";
//		} else if (type == 4) { // 绑定银行卡
//			templateCode = "smsTpl:e7476122a1c24e37b3b0de19d04ae901";
//		} else if (type == 5) { // 修改支付密码验证码
//			templateCode = "SMS_81620087";
//		}
//        
//        Map<String, String> vars = new HashMap<String, String>(); // 若模板内容为：您的验证码是${code},在${time}分钟内输入有效
//        vars.put("code", code);
//        
//        //实例化请求对象
//        SendMessageV2Request request = new SendMessageV2Request();
//        request.withInvokeId(invokeId)
//                .withPhoneNumber(phone)
//                .withTemplateCode(templateCode)
//                .withContentVar(vars);
//
//        // 发送请求
//        SendMessageV2Response response = smsClient.sendMessage(request);
//
//        // 解析请求响应 response.isSuccess()为true 表示成功
//        if (response != null && response.isSuccess()) {
//           return 1;
//        } else {
//        	return -1;
//        }
//
//	}
	
//	public static int sendCode(String phone, String code, int type) {
//		String url = "http://api.scsj.net.cn/sms?token=c1e5a22922af88c7483aa86bde1ccae9";
//		Map<String,String> params = new HashMap<>();
//		params.put("phoneNo", phone);
//		params.put("sn", code);
//		String msg = "";
//		try {
//			msg = HttpUtil.get(url, params, null);
//		} catch (Exception e) {
//			// TODO Auto-generated catch block
//			return 0;
//		}
//		int ret = 1;
//		if(StringUtil.isNotBlank(msg)){
//			JSONObject result = JSON.parseObject(msg);
//			ret = result.getIntValue("ret");
//			if(ret==0)
//				ret = 1;
//			else
//				ret = 0;
//		}
//		
//		return ret;
//	}
	
	public static int sendMsg(String phone,String content) {
		String sign = "【东旭通】";
		String url = "http://api.scsj.net.cn/smsNotice?token=c1e5a22922af88c7483aa86bde1ccae9";
		Map<String,String> params = new HashMap<>();
		params.put("phoneNo", phone);
		params.put("content", sign+content);
		 
		String msg = "";
		try {
			msg = HttpUtil.post(url, params, null);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			return 0;
		}
		int ret = 1;
		if(StringUtil.isNotBlank(msg)){
			JSONObject result = JSON.parseObject(msg);
			ret = result.getIntValue("ret");
			if(ret==0)
				ret = 1;
			else
				ret = 0;
		}
		
		return ret;
	}
	public static void main(String[] args){

		sendCode("13673397960", "1234", 1);

	}
}
